(setq *sch* (make-hash-table :test #'equal))
(setq *scharity* (make-hash-table :test #'equal))
(setq *sersch* (make-hash-table :test #'equal))
(setq *eigen* (make-hash-table :test #'equal))
(setq *eigen2* (make-hash-table :test #'equal))
(setq *ap* nil)
(setq *an* nil)
(setq *pp* nil)
(setq *pn* nil)
(setq *pi* nil)
(setq *assertedposprop* (make-hash-table :test #'equal))
(setq *assertednegprop* (make-hash-table :test #'equal))
(setq *goodposprop* (make-hash-table :test #'equal))
(setq *goodnegprop* (make-hash-table :test #'equal))
(setq *goodinst* (make-hash-table :test #'equal))
(setq *badposprop* (make-hash-table :test #'equal))
(setq *badnegprop* (make-hash-table :test #'equal))
(setq *badinst* (make-hash-table :test #'equal))

(defun read-trainingdatafile (fn)
  (setq f (open fn :direction :input))
  (loop while (setq s (read f nil nil)) do
    (when (consp s)
      (case (car s)
         (SUBGOAL (setq *ap* nil *an* nil *pi* nil *pp* nil *pn* nil))
         (ASSERT (if (eq (cadr s) 'POS) (progn (setf (gethash (caddr s) *assertedposprop*) t) (push (caddr s) *ap*)) (progn (setf (gethash (caddr s) *assertednegprop*) t) (push (caddr s) *an*))))
         (EIGEN (setf (gethash (cadr s) *eigen*) (caddr s)) (setf (gethash (caddr s) *eigen2*) (cadr s)))
         (SERSCH (setf (gethash (cadr s) *sersch*) (caddr s)))
         (SCH (setf (gethash (cadr s) *sch*) (cddr s)) (setf (gethash (caddr s) *scharity*) (length (cdddr s))))
         (+ (cond ((eq (cadr s) 'POS)
                   (progn (push (caddr s) *pp*) (push (list *ap* *an* *pp* *pn* *pi*) (gethash (caddr s) *goodposprop*))))
                  ((eq (cadr s) 'NEG)
                   (progn (push (caddr s) *pn*) (push (list *ap* *an* *pp* *pn* *pi*) (gethash (caddr s) *goodnegprop*))))
                  ((eq (cadr s) 'INST)
                   (progn (push (caddr s) *pi*) (push (list *ap* *an* *pp* *pn* *pi*) (gethash (caddr s) *goodinst*))))
                  (t nil)))
         (- (cond ((eq (cadr s) 'POS)
                   (progn (push (list *ap* *an* *pp* *pn* *pi*) (gethash (caddr s) *badposprop*))))
                  ((eq (cadr s) 'NEG)
                   (progn (push (list *ap* *an* *pp* *pn* *pi*) (gethash (caddr s) *badnegprop*))))
                  ((eq (cadr s) 'INST)
                   (progn (push (list *ap* *an* *pp* *pn* *pi*) (gethash (caddr s) *badinst*))))
                  (t nil)))
        (t nil))))
  (close f))

(setq *goodpospropsch* (make-hash-table :test #'equal))
(setq *badpospropsch* (make-hash-table :test #'equal))
(setq *goodnegpropsch* (make-hash-table :test #'equal))
(setq *badnegpropsch* (make-hash-table :test #'equal))
(setq *goodinstsch* (make-hash-table :test #'equal))
(setq *badinstsch* (make-hash-table :test #'equal))

(setq *maxconds* 4)

(defun cand-cond-sets (il jl el cl ccl)
  (if (< (length ccl) *maxconds*)
      (if el
	  (let ((es (nth 1 (car el)))
		(i (nth 2 (car el)))
		(jl2 (nth 3 (car el))))
	    (append (cand-cond-sets il (append (cons i jl2) jl) (cdr el) cl (cons (car el) ccl))
		    (cand-cond-sets il jl (cdr el) cl ccl)))
	(if cl
	    (let* ((k (caar cl))
		   (y (cdar cl))
		   (schjl (gethash y *sch*)))
	      (if (and schjl (intersection (cdr schjl) (append il jl) :test #'equal))
		  (append (cand-cond-sets il (append (cdr schjl) jl) nil (cdr cl) (cons (list k (car schjl) (cdr schjl)) ccl))
			  (cand-cond-sets il jl nil (cdr cl) ccl))
		(cand-cond-sets il jl nil (cdr cl) ccl)))
	  (if (subsetp il jl :test #'equal)
	      (list ccl)
	    nil)))
    (if (subsetp il jl :test #'equal)
	(list ccl)
      nil)))

(defun generate-forward-rules-for (lab h x)
  (let* ((ctxl (gethash x h))
	 (schil (gethash x *sch*))
	 (schid (car schil))
	 (il (cdr schil))
	 (el nil)
	 (rl nil))
    (dolist (i il)
      (let ((e (gethash i *eigen*)))
	(when e
	  (let ((schjl (gethash e *sch*)))
	    (when schjl
	      (push (list 'EIGEN (car schjl) i (cdr schjl)) el))))))
    (dolist (ctx ctxl rl)
      (let ((ap (mapcar #'(lambda (y) (cons 'AP y)) (remove-if #'(lambda (y) (equal y x)) (car ctx))))
	    (an (mapcar #'(lambda (y) (cons 'AN y)) (remove-if #'(lambda (y) (equal y x)) (cadr ctx))))
	    (pp (mapcar #'(lambda (y) (cons 'PP y)) (remove-if #'(lambda (y) (equal y x)) (nth 2 ctx))))
	    (pn (mapcar #'(lambda (y) (cons 'PN y)) (remove-if #'(lambda (y) (equal y x)) (nth 3 ctx))))
	    (pinsts (mapcar #'(lambda (y) (cons 'PINST y)) (remove-if #'(lambda (y) (equal y x)) (nth 4 ctx)))))
	(let ((candcondsl (cand-cond-sets il nil el (append ap an pinsts pp pn) nil)))
	  (dolist (conds candcondsl)
	    (push (list lab schid il conds) rl)))))))

(setq *iassoc* nil)

(defun grule-il-str (il)
  (if il
      (let* ((i (car il))
	     (a (assoc i *iassoc* :test #'equal)))
	(if a
	    (format nil " X~d~d" (cdr a) (grule-il-str (cdr il)))
	  (let ((n (length *iassoc*)))
	    (push (cons i n) *iassoc*)
	    (format nil " X~d~d" n (grule-il-str (cdr il))))))
    ""))

(defun grule-conds-str (conds)
  (if conds
      (let* ((c (car conds))
	     (k (car c))
	     (schid (cadr c)))
	(if (eq k 'EIGEN)
	    (let ((i (nth 2 c))
		  (jl (nth 3 c)))
	      (format nil " eigen ~d~d~d" schid (grule-il-str (cons i jl))
		      (if (cdr conds)
			  (format nil ",~d" (grule-conds-str (cdr conds)))
			";")))
	  (let ((jl (nth 2 c)))
	    (format nil " ~d ~d~d~d"
		    (case k
			  (AP "assertedpos")
			  (AN "assertedneg")
			  (PP "processedpos")
			  (PN "processedneg")
			  (PINST "processedinst")
			  (t (break)))
		    schid (grule-il-str jl)
		    (if (cdr conds)
			(format nil ",~d" (grule-conds-str (cdr conds)))
		      ";")))))
    (break)))

(defun kindlt (c1 c2)
  (case c1
	(EIGEN (not (eq c2 'EIGEN)))
	(AP (not (member c2 '(AP EIGEN))))
	(AN (not (member c2 '(AN AP EIGEN))))
	(PP (not (member c2 '(PP AN AP EIGEN))))
	(PN (not (member c2 '(PN PP AN AP EIGEN))))
	(t nil)))

(defun condlt (c1 c2)
  (or (kindlt (car c1) (car c2))
      (and (eq (car c1) (car c2)) (string< (cadr c1) (cadr c2)))))

(defun sortconds (l)
  (sort (copy-list l) #'condlt))

(defun grule-str (l)
  (let ((k (car l))
	(schid (cadr l))
	(il (caddr l))
	(conds (sortconds (cadddr l))))
    (setq *iassoc* nil)
    (case k
	  (FORWGOODPOS
	   (format nil "pos ~d~d:~d"
		   schid
		   (grule-il-str il)
		   (grule-conds-str conds)))
	  (FORWBADPOS
	   (format nil "-pos ~d~d:~d"
		   schid
		   (grule-il-str il)
		   (grule-conds-str conds)))
	  (FORWGOODNEG
	   (format nil "neg ~d~d:~d"
		   schid
		   (grule-il-str il)
		   (grule-conds-str conds)))
	  (FORWBADNEG
	   (format nil "-neg ~d~d:~d"
		   schid
		   (grule-il-str il)
		   (grule-conds-str conds)))
	  (FORWGOODINST
	   (format nil "inst ~d~d:~d"
		   schid
		   (grule-il-str il)
		   (grule-conds-str conds)))
	  (FORWBADINST
	   (format nil "-inst ~d~d:~d"
		   schid
		   (grule-il-str il)
		   (grule-conds-str conds)))
	  (t (break)))))

(defun top ()
  (let ((n (member "-i" sb-ext:*posix-argv* :test #'equal))
	(m (member "-o" sb-ext:*posix-argv* :test #'equal)))
    (if (and n m)
	(let ((cutcands nil))
	  (read-trainingdatafile (cadr n))
	  (maphash #'(lambda (k v) (when (gethash k *goodnegprop*) (push k cutcands))) *goodposprop*)
	  (dolist (ph cutcands)
	    (let ((schil (gethash ph *sch*)))
	      (when schil
		(let* ((sch (car schil))
		       (il (cdr schil))
		       (schs (gethash sch *sersch*)))
		  (when schs
		    (let ((rl1 (generate-forward-rules-for 'FORWGOODPOS *goodposprop* ph)))
		      (when (< (length rl1) 50000) ; give up if too many
			(let ((*posrule* (make-hash-table :test #'equal)))
			  (dolist (r rl1)
			    (let ((rs1 (grule-str r)))
			      (setf (gethash (subseq rs1 4) *posrule*) t)))
			  (let ((rl2 (generate-forward-rules-for 'FORWGOODNEG *goodnegprop* ph)))
			    (when rl2
			      (let ((g (open (cadr m) :direction :output :if-exists :append :if-does-not-exist :create)))
				(format g "schema ~d ~d;~%" sch schs)
				(dolist (r rl2)
				  (let ((rs2 (grule-str r)))
				    (when (gethash (subseq rs2 4) *posrule*)
				      (format g "cut ~d~%" (subseq rs2 4)))))
				(close g)))))))))))))
      (format t "Sorry, got confused. Expected 'cutlearner -i filenamein -o filenameout'~%"))
    (exit)))

(sb-ext:save-lisp-and-die "cutlearner" :toplevel #'top :executable t)
